#!/usr/bin/env groovy
def ec2_ip=""
def selenium_grid=""
boolean selenium_ok=true
node{
    stage('Cleanup'){
        cleanWs()
    }
    stage('Git Chekout'){
        checkout scm
        echo "pulling code from git"
    }
    stage('Setup Selenium Grid in AWS'){
        echo "executing terraform code: init, plan and aplly"
        withCredentials([aws(credentialsId: 'aws-user-default', accessKeyVariable: 'AWS_ACCESS_KEY_ID', secretKeyVariable: 'AWS_SECRET_ACCESS_KEY')]) {
            sh "cd terraformCode;terraform init -input=false"
            sh "cd terraformCode;terraform plan -input=false -out=tfplan"
            sh "cd terraformCode;terraform apply -auto-approve" 
        }

    }   
    stage('Start Selenium Grid'){
        def props = readProperties  file:'terraformCode/ec2.properties'
        ec2_ip=props['public_ip']
        echo "Public IP of ec2-instance: ${ec2_ip}"
        selenium_grid="http://${ec2_ip}:4444"
        try{
            echo "Running docker-compose command in remote ec2"
            sh "cd terraformCode;ssh -i ./login-keypair-seleniumgrid.pem -o StrictHostKeyChecking=no ec2-user@${ec2_ip} 'docker-compose up -d'"
            //wait until selenium grid responses
            timeout(time: 5, unit: 'MINUTES'){
                sh "until \$(curl --output /dev/null --silent --head --fail ${selenium_grid}); do printf '\n'; printf 'WAITING......';sleep 5; done"
            }
            //sh "if timeout 300s curl --output /dev/null --silent --head --fail ${selenium_grid}; then echo 'OK'>out;else echo 'FAILED'>out; fi"
            //get http response from selenium grid
            sh "curl -s -o /dev/null ${selenium_grid} -w '%{http_code}' > outFile"
            status = readFile 'outFile'
            status = status.trim()
            echo "Checking the status of the selenium grid"
            if (status=="200"){
                echo "Selenium Grid: ${selenium_grid} is up and running"
                selenium_ok=true
            }else{
                echo "Selenium Grid not running"
                selenium_ok=false
            }
        }catch(Exception e){
            println("Catching the exception: ${e}")
        }
        
    }
    stage('Run Cucumber Test'){
        try{
            if(selenium_ok){
                echo "Running Cucumber Test"
                sh "mvn -DhubUrl=${selenium_grid}/wd/hub -Dbrowser=${Browser} clean test"
            }else{
                echo "Selenium hub is not running, skipping cucumber test"
        }
        }catch(Exception ex){
            println("Catching the exception: ${ex}")
        }finally{
            stage('Remove Selenium grid'){
            echo "terraform destroy infrastructure"
                withCredentials([aws(credentialsId: 'aws-user-default', accessKeyVariable: 'AWS_ACCESS_KEY_ID', secretKeyVariable: 'AWS_SECRET_ACCESS_KEY')]) {
                    sh "cd terraformCode;terraform destroy -auto-approve"
                }
            }
        }
        
    }
    stage('Cucumber Reporting'){
        cucumber buildStatus: "UNSTABLE",
                reportTitle: 'Selenium Cucumber Report',
                fileIncludePattern: '**/*.json',
                jsonReportDirectory: 'target/cucumber-reports',
                classifications: [
                        [
                                'key': 'Browser',
                                'value': Browser
                        ]
                ]

    }
}